var version = (function () {
    var u = window.navigator.userAgent
    return {// 移动终端浏览器版本信息
        trident: u.indexOf('Trident') > -1, // IE内核
        presto: u.indexOf('Presto') > -1, // opera内核
        webKit: u.indexOf('AppleWebKit') > -1, // 苹果、谷歌内核
        gecko: u.indexOf('Gecko') > -1 && u.indexOf('KHTML') === -1, // 火狐内核
        mobile: !!u.match(/AppleWebKit.*Mobile/i) || !!u.match(/MIDP|SymbianOS|NOKIA|SAMSUNG|LG|NEC|TCL|Alcatel|BIRD|DBTEL|Dopod|PHILIPS|HAIER|LENOVO|MOT-|Nokia|SonyEricsson|SIE-|Amoi|ZTE/), // 是否为移动终端
        ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), // ios终端
        android: u.indexOf('Android') > -1 || u.indexOf('Linux') > -1, // android终端或者uc浏览器
        iPhone: u.indexOf('iPhone') > -1 || u.indexOf('Mac') > -1, // 是否为iPhone或者QQHD浏览器
        iPad: u.indexOf('iPad') > -1, // 是否iPad
        webApp: u.indexOf('Safari') === -1 // 是否web应该程序，没有头部与底部
    }
}());

function setupWebViewJavascriptBridge(callback) {
    if (window.WebViewJavascriptBridge) { return callback(WebViewJavascriptBridge); }
    if (window.WVJBCallbacks) { return window.WVJBCallbacks.push(callback); }
    window.WVJBCallbacks = [callback];
    var WVJBIframe = document.createElement('iframe');
    WVJBIframe.style.display = 'none';
    WVJBIframe.src = 'https://__bridge_loaded__';
    document.documentElement.appendChild(WVJBIframe);
    setTimeout(function() { document.documentElement.removeChild(WVJBIframe) }, 0)
}

function connectWebViewJavascriptBridge(callback) {
    if (window.WebViewJavascriptBridge) {
        callback(WebViewJavascriptBridge)
    } else {
        document.addEventListener('WebViewJavascriptBridgeReady', function() {
            callback(WebViewJavascriptBridge)
        }, false)
    }
}


var swqhapp = {
    excuteNativeMethod: function(jsonObj){
        if(version.android){
            //window.WebViewUtil.nativeMethod(JSON.stringify(jsonObj));
            connectWebViewJavascriptBridge(function(bridge) {
				bridge.init(function(message, responseCallback) {
		        });
                //向原生发送数据（有反馈）
                bridge.callHandler('notifyTheNative', jsonObj, function(response) {
                    // log('JS got response', response)
                    if(jsonObj.callback){
                        jsonObj.callback(response);
                    }
                });
                //等待原生发送数据到JS
                bridge.registerHandler('notifyTheJS', function(data, responseCallback) {
                    var responseData = data;//JSON.parse(data);
                    if (responseData.methodId==20001) {
                        window.reload();//返回刷新
                    }else if (responseData.methodId==20002) {//原生通知，可以传参
                        if (responseData.methodParams!=null&&responseData.methodParams!=undefined&&responseData.methodParams!='') {
                            window.nativeNotification(responseData.methodParams);
                        }else {
                            window.nativeNotification('');
                        }
                    }else if (responseData.methodId==20003) {
                        window.customFunc('');//自定义方法
                    }
                })
            })
        }else if(version.ios){
            // window.webkit.messageHandlers.nativeMethod.postMessage(JSON.stringify(jsonObj));
            setupWebViewJavascriptBridge(function(bridge) {
                //等待原生发送数据到JS
                bridge.registerHandler('notifyTheJS', function(data, responseCallback) {
                    var responseData = JSON.parse(data);
                    if (responseData.methodId==20001) {
                        window.reload();//返回刷新
                    }else if (responseData.methodId==20002) {//原生通知，可以传参
                        if (responseData.methodParams!=null&&responseData.methodParams!=undefined&&responseData.methodParams!='') {
                            window.nativeNotification(responseData.methodParams);
                        }else {
                            window.nativeNotification('');
                        }
                    }else if (responseData.methodId==20003) {
                        window.customFunc('');//自定义方法
                    }
                });
                //向原生发送数据（有反馈）
                bridge.callHandler('notifyTheNative',JSON.stringify(jsonObj) , function responseCallback(response) {
                    // console.log('JS got response', response);
                    if(jsonObj.callback){
                        jsonObj.callback(response);
                    }
                })
            })
        }
    }
};
