/**
 *
 * 模块公用 js
 */
define('information/scripts/common/common.js', function(require, exports, module) {
	require("msgFunction");
	var nativePluginService = require("nativePluginService");
	var constants = require("constants");
	require('validatorUtils');

	var mainConfig, news, contract, contractInterval, prevCustom, navScroll, newsData, newsCurrent, prevConfig;
	var pbHQ, pbSYS, pbINFO, pbZX;
	var isPoboApp = typeof pbE != "undefined";
	var HISTORY = 9;
	var SELF = 100;
	var HOT = 100;

	var poboNumber = '123';
	var deviceId = '127.0.0.1';
	var OS = 'Android';
	var version = '1.0.0.1';
	var orgNumber = '789'; //券商编号

	/**
	 * 每次页面跳转之前都会执行的方法
	 * @fromPage 当前页面对象
	 * @toPage 要跳转的页面地址
	 * @param 传递的目标页面的参数
	 */
	function checkPermission(fromPage, toPageUrl, param) {
		//控制资讯详情页面的字体大小
		if($.validatorUtils.isNotEmpty($.getSStorageInfo("fontSize"))) {
			if(toPageUrl.pageCode == "details") {
				$("html").css("font-size", $.getSStorageInfo("fontSize"));
			} else {
				$("html").css("font-size", "100px");
			}

		}
		/*   //非首页禁止滑动打开侧边栏  openType 0 关闭  1 打开  2 使能  3 禁止
		   if (pageId == "index") {
		       //使能滑动打开侧边栏
		       var param = {};
		       param["moduleName"] = 'main';
		       param["menuType"] = '0';
		       param["openType"] = "2";
		       nativePluginService.function50102(param);
		   } else {
		       //禁止滑动打开侧边栏
		       var param = {};
		       param["moduleName"] = 'main';
		       param["menuType"] = '0';
		       param["openType"] = "3";
		       nativePluginService.function50102(param);
		   }*/
		return true;
	}

	/**
	 * 首次进入模块的时候，调用
	 *里面可以写同步和异步操作
	 */
	function firstLoadFunc() {

	}

	/**
	 * 统一退出,通常返回-999未登录，需要将当前未登录页面相关信息返回给前端
	 * */
	function filterLoginOut(curPage) {

	}

	/**
	 * 公共是否登录判断
	 */
	function isLogin() {

	}
	/***********************************彭博数据    begin**********************************************/
	function PoboApp() {
		if(isPoboApp) {
			pbHQ = pbE.HQ();
			pbSYS = pbE.SYS();
			pbZX = pbE.ZX();
			pbINFO = pbE.INFO();
		}
	}

	//彭博方式获取数据
	function PoboParam() {
		PoboApp();
		var poboParams = {};
		//
		//客户端MAC
		var devoceInfo = JSON.parse(pbSYS.getDeviceJsonInfo());
		for(var key in devoceInfo) {
			if(key == 72) {
				poboParams.mac_token = devoceInfo[key];
			}
		}
		poboParams.orgNumber = orgNumber;
		if(deviceInfo1) {
			//客户端本机IP地址
			if(deviceInfo['71']) {
				poboParams.deviceId = $.validatorUtils.isNotEmpty(deviceInfo['71']) ? deviceInfo['71'] : deviceId; //客户端本机ip地址
			}
			//平台值
			if(deviceInfo['255']) { //平台
				poboParams.OS = poboParams.OS = (deviceInfo['255'] == '2') ? 'iOS' : 'Android';
				$.validatorUtils.isNotEmpty
			}
			//版本号
			if(deviceInfo['73']) {
				poboParams.version = $.validatorUtils.isNotEmpty(deviceInfo['73']) ? deviceInfo['73'] : version; //版本号
			}
			//机构代码
			if(deviceInfo['jgid']) {
				poboParams.orgNumber = $.validatorUtils.isNotEmpty(deviceInfo['jgid']) ? deviceInfo['jgid'] : orgNumber; //机构代码/券商编号
			}
		}

		poboParams.token = pbE.SYS().getAppCertifyInfo('PbKey_H5_Home_Auth_Token'); //获取令牌：
		poboParams.user_id = pbE.SYS().getPublicData('user_id'); //获取用户编号：
		poboParams.loginName = pbE.SYS().getAppCertifyInfo('PbKey_H5_Home_Auth_LoginName'); //获取登录名：
		poboParams.uid = pbE.SYS().getAppCertifyInfo('PbKey_H5_Home_Auth_UserId'); //获取用户ID：

		return poboParams;
	}

	//彭博方式存储登录信息
	function saveSessionUserInfo(data) {
		PoboApp();

		var userInfo = data[0];
		pbE.SYS().storePublicData("userInfo", userInfo);
		pbE.SYS().storePublicData("user_id", userInfo.user_id);
		pbE.SYS().storePublicData("mobile", userInfo.mobile_phone);
		pbE.SYS().storePublicData("image", userInfo.user_icon);
	}

	/***********************************彭博数据    end**********************************************/

	function timeBucket(time) {
		//发布日期
		var ptime = time.replace(/\-/g, "/");
		_ptime = new Date(ptime);
		//当前日期
		var date = new Date(new Date());
		//var date = new Date("2014/01/21 15:03:54");
		//两时间的毫秒差
		var s = date - _ptime;
		
		
		
		/*
		 * 判断发布文档时间与查看文档时间的具体时间差，
		 * 距离8个月的显示具体时间，
		 * 距离1 个月 到8 个月之间的，显示 *个月 前 ，
		 * 距离一个月之内的，显示 *天 前
		 * 距离一天之内的，显示 *小时前，*分钟前，*秒前，
		 *
		 * */
//		if(s >= 1000 * 60 * 60 * 24 * 30 * 12 * 4) { //4年后
//			return time;
//		} else if((1000 * 60 * 60 * 24 * 30 * 12 <= s) && (s < 1000 * 60 * 60 * 24 * 30 * 12 * 4)) { //1年 到4年之间
//			return "" + Math.floor(s / (1000 * 60 * 60 * 24 * 30 * 12)) + " 年前";
//		} else if((1000 * 60 * 60 * 24 * 30 * 1 <= s) && (s < 1000 * 60 * 60 * 24 * 30 * 12)) { //1 个月 到1年之间
//			return "" + Math.floor(s / (1000 * 60 * 60 * 24 * 30)) + " 个月前";
//		} else if((1000 * 60 * 60 * 24 * 1 <= s) && (s < 1000 * 60 * 60 * 24 * 30)) { //一个月之内
//			return "" + Math.floor(s / (1000 * 60 * 60 * 24)) + " 天前";
//		} else if((1000 * 60 * 60 <= s) && (s < 1000 * 60 * 60 * 24 * 1)) { //1天之内
//			return "" + Math.floor(s / (1000 * 60 * 60)) + " 小时前";
//		} else if((1000 * 60 <= s) && (s < 1000 * 60 * 60)) {
//			return "" + Math.floor(s / (1000 * 60)) + " 分钟前";
//		} else if((1000 <= s) && (s < 1000 * 60)) {
//			return "" + Math.floor(s / (1000)) + " 秒前";
//		} else if((0 <= s) && (s < 1000)) {
//			return "刚刚";
//		} else if(s < 0) {
//			return "刚刚";
//		}
		if(s >= 1000 * 60 * 60 * 24 * 30 * 12 * 4) { //4年后
//					return time;
// 			return time.substring(5,10);
			var arr=time.split(' ');
			return arr[0];
		} else if((1000 * 60 * 60 * 24 * 30 * 12 <= s) && (s < 1000 * 60 * 60 * 24 * 30 * 12 * 4)) { //1年 到4年之间
			// return time.substring(5,10);
			// return "" + Math.floor(s / (1000 * 60 * 60 * 24 * 30 * 12)) + " 年前";
			var arr=time.split(' ');
			return arr[0];
		} else if((1000 * 60 * 60 * 24 * 30 * 1 <= s) && (s < 1000 * 60 * 60 * 24 * 30 * 12)) { //1 个月 到1年之间
			// return time.substring(5,10);
			// return "" + Math.floor(s / (1000 * 60 * 60 * 24 * 30)) + " 个月前";
			var arr=time.split(' ');
			return arr[0].substring(5);
		} else if((1000 * 60 * 60 * 24 * 1 <= s) && (s < 1000 * 60 * 60 * 24 * 30)) { //一个月之内
			// return "" + Math.floor(s / (1000 * 60 * 60 * 24)) + " 天前";
			// return  time.substring(5,10);
			var arr=time.split(' ');
			return arr[0].substring(5);
		} else if((1000 * 60 * 60 <= s) && (s < 1000 * 60 * 60 * 24 * 1)) { //1天之内
			return "" + Math.floor(s / (1000 * 60 * 60)) + " 小时前";
		} else if((1000 * 60 <= s) && (s < 1000 * 60 * 60)) {
			return "" + Math.floor(s / (1000 * 60)) + " 分钟前";
		} else if((1000 <= s) && (s < 1000 * 60)) {
			return "" + Math.floor(s / (1000)) + " 秒前";
		} else if((0 <= s) && (s < 1000)) {
			return "刚刚";
		} else if(s < 0) {
			return "刚刚";
		}
	}

	var common = {
		"firstLoadFunc": firstLoadFunc,
		"checkPermission": checkPermission,
		"filterLoginOut": filterLoginOut,
		"saveSessionUserInfo": saveSessionUserInfo,
		"timeBucket": timeBucket,
		"isLogin": isLogin,
		"PoboParam": PoboParam,
		"PoboApp": PoboApp
	};

	module.exports = common;
});