/**
 *   资讯栏目-更多
 */
define('information/scripts/search.js', function(require, exports, module) {
	var pageId = '#search';
	require('validatorUtils');
	var commonExt = require('commonExt');
	var common = require('common');
	var informationService = require("information/services/informationService").getInstance();
	var VIscroll = require("vIscroll"); //vIscroll别名已经配置到hSea中
	var global = $.config.global; //全局配置对象
	var myVIscroll = null;
	
	var pageNum = 1;//页数
	var totalRows = 1; //总页数
	var show_height;
	
	//栏目编号
	var titleNo = new Array();
	titleNo[0] = ["10101"]; //今日要闻
	titleNo[1] = ["10301"]; //金融财经
	titleNo[2] = ["40102", "40202"]; //稀贵金属
	titleNo[3] = ["10401"]; //公司公告
	
	function init(){
		var searchStr = $.getPageParam("searchStr");
		if (searchStr!==''&&searchStr!==undefined&&searchStr!==null){
			$("#key").val(searchStr);
			searchInfo(1,false);
		}
	}
	
	function bindPageEvent() {
		//查询
		$.bindEvent($(pageId + " #search_info"), function() {
			searchInfo(1,false);
		});
		
		//进入详情
		$.preBindEvent($(pageId + " #results"), "li", function() {
			// window.open($(this).attr("href"));
			swqhapp.excuteNativeMethod({
				methodId: 10002,
				methodParams: {
					dispatchType: 5 ,
					url: $(this).attr("href"),
					isNeedLogin: 0
				}, callback: function(callbackdata){
					console.log(callbackdata);
				}
			});
		});
		
		//绑定返回按钮
		$.bindEvent($(pageId + " .icon_back"), function() {
			// window.location.href = 'goBack';
			swqhapp.excuteNativeMethod({
				methodId: 10001
			});
		});
    }

	function searchInfo(curPageNo,isAppendFlag){
		var param = {
			"key": $(pageId+" #key").val(),
			"pageNum": curPageNo,
			"pageSize": 15
		};
		$(pageId + ' .visc_pullUp').css("display", "none;");
		informationService.getAnnouncement(param, function(resultVo) {
			if(resultVo.error_no == 0) {
				totalRows = resultVo.results[0].totalPages;
				var data = resultVo.results[0].data;
    			var content = "";
				if(data&&data.length>0){
					var id = "";
					var Pcategory_id = "";
					var category_id = "";
					var news_date = "";
					var title = "";
					var titles = "";
					var news_short_date = "";
					for(var i=0,len=data.length;i<len;i++){
						id = data[i].id;
						Pcategory_id = data[i].Pcategory_id;
						category_id = data[i].category_id;
						news_date = data[i].news_date;
						title = data[i].news_title;
						titles = title.replace(param.key, "<i>"+param.key+"</i>");
						news_short_date =common.timeBucket(news_date);
						content += "<li href='/pbres/web1/modules/main/information/views/details.html?newsid=" + id + "&url_ids=" + titleNo[3] + "&Pcategory_id=" + Pcategory_id + "&category_id=" + category_id + "'><p>"+titles+"</p><em style='text-align: right;padding-right: 0.15rem;'>"+news_short_date+"</em></li>";
					}
					if(isAppendFlag){
						$(pageId + " #results").append(content);
					}else{
						$(pageId + " #results").html(content);
					}

					//加载下拉刷新效果以及一些特殊处理
					$(pageId+" .visc_pullUp").show();
					initVIscroll();

					if(pageNum>=totalRows){
						$(pageId+" .visc_pullUp").hide();
						totalRows = 1;
					}
					else{
						$(pageId+" .visc_pullUp").show();
					}
				}else{
					$(pageId + " #results").html("");
					$(pageId + " .visc_pullUp").hide();
				}
			}
		}, {
			"isShowWait": false
		});
	}
	
	
	function initVIscroll() {
		show_height = $(window).height() - $(pageId + " .header").height();
		if(!myVIscroll) {
			var config = {
				"isPagingType": false,
				"visibleHeight": show_height, //要理解这个属性表示的含义，表示中间显示区域的高度。累加的数据内容高度不超过这个高度，超出部分可以滑动
				"container": $(pageId + " #container_yourname"),
				"wrapper": $(pageId + " #wrapper_yourname"),
				"downHandle": function() {
					pageNum = 1;
					searchInfo(pageNum,false);
				},
				"upHandle": function() {
					//上拉回调处理
					if(pageNum<totalRows){
						$(pageId+" .visc_pullUp").show();
						pageNum+=1;
						searchInfo(pageNum,true);
					}
					else{
						$(pageId + ".visc_pullUp").hide();
						totalRows=1;
						myVIscroll.refresh();
					}
				}
			};
			myVIscroll = new VIscroll(config);
		} else {
			show_height = $(window).height() - $(pageId + " .header").height();
			var config = {
				"isPagingType": false,
				"visibleHeight": show_height //要理解这个属性表示的含义，表示中间显示区域的高度。累加的数据内容高度不超过这个高度，超出部分可以滑动
			};
			myVIscroll.refresh(config);
		}
	}

	/**
	 * 对日期进行过滤：当天的返回多少小时，否则返回具体日期
	 */
	function dateFilter(str){
		var time = "";
		var str2 = str.substr(0,10);
		var d = new Date(str2.replace(/\-/g,"/"));
		var todaysDate = new Date();
		if(d.setHours(0,0,0,0) == todaysDate.setHours(0,0,0,0)){
			var str3 = new Date(str.replace(/\-/g, '/'));
			time = new Date().getTime() - str3.getTime();
			time = time / 1000 / 60 / 60;
			if(time>=1){
				time = parseInt(time);
			}else{
				time = Math.floor(time * 10) / 10;
			}
			time = time+"小时前";
		} else {
			time = str2;
		}
		return time;
	}
	
    function destroy() {}

	function pageBack() {}

	function load() {
		pageNum = 1;
		totalRows = 1;
	}
	
	var search = {
	        init: init,
	        bindPageEvent: bindPageEvent,
	        destroy: destroy,
	        pageBack: pageBack,
	        load: load
	};

	module.exports = search;
});